<?php

// --------------------------------------------------------------------------
//
// Esvon Classifieds v.4.0
// Copyright(C), Esvon LTD, 2001-2010, All Rights Reserved.
// E-mail: products@esvon.com
//
// All forms of reproduction, including, but not limited to, internet posting, 
// printing, e-mailing, faxing and recording are strictly prohibited.
// One license required per site running Esvon Classifieds. 
// To obtain a license for using Esvon Classifieds, please register at
// http://www.esvon.com/pg/products/p_classifieds/
//
// --------------------------------------------------------------------------

$A_MOD = array(
  'dir' => 'Cron_General',
  'descr' => 'Cron Job to send expiration notifications, delete expired listings, expire paid listings/membership',
);

$A_CFG = array(
  
  'EN_TBL_OPT' => 1,
  'EN_DEL_EXP' => 0,
  'EXP_DAYS_TO_LIVE' => 7,
  'EN_ADM_R' => 1,
  'EN_EXP_R' => 0,
  'EXP_FOR_PAYM' => 30,
  'LIVE_TRANS' => 0,
  'OLD_USER' => 0, // remove users who do not have ads and have no activity, days
  'NOEXP_DEL' => 0, // remove ads without expiration date, days

);

$A_TBL = array(
  
  'remind' => "CREATE TABLE remind (
   id mediumint(8) unsigned NOT NULL auto_increment,
   type char(5) NOT NULL,
   plan varchar(20) NOT NULL,
   days smallint(5) unsigned NOT NULL,
   mail_subj varchar(255) NOT NULL,
   mail_body text,
   enabled tinyint(3) unsigned NOT NULL,
   PRIMARY KEY (id))",
  
  'extra_remind' => "CREATE TABLE extra_remind (
   id int unsigned NOT NULL auto_increment,
   ad_id mediumint(8) unsigned NOT NULL,
   opt_id varchar(10) NOT NULL,
   opt_val varchar(10) NOT NULL,
   exp_date DATETIME NOT NULL,
   hw_remind smallint(5) DEFAULT '-1' NOT NULL,
   UNIQUE (ad_id,opt_id),
   PRIMARY KEY (id))",

  'log' => "CREATE TABLE log (
   id int unsigned NOT NULL auto_increment,
   entry varchar(255) NOT NULL,
   added DATETIME NOT NULL,
   KEY (added),
   PRIMARY KEY (id))",

);

$A_FIELDS = array(

  TBL_AD => array(
    'hw_remind smallint(5) DEFAULT "-1" NOT NULL',
  ),

  TBL_USER => array(
    'hw_remind smallint(5) DEFAULT "-1" NOT NULL',
  ),
 
);

$A_EXTRA_SQL = array(

  "INSERT INTO remind VALUES 
(1, 'SUB', '', 14, 'Account Expiration Warning (14 days left)', ' Dear ##username##!\n\n We''d like to remind you that in ##hw_days_rem## days your account will expire.\n \n You can upgrade your membership here:\n##SITE_URL##index.php?page=order\n\n Regards,\n\n ##COMPANY##\n ##SITE_URL##', 1),
(2, 'FEE', '', 14, 'Listing Expiration Warning (14 days left)', 'Dear Member!\n\nWe''d like to remind you that in ##hw_days_rem## days your listing will expire.\n\n--- Listing details ---\n\nURL : ##SITE_URL####ad_url##\nID : ##link_id##\nCategory : ##cname##\n##email_rows##\n\n\nRegards,\n\n##COMPANY##\n##SITE_URL##', 1),
(3, 'FEE', '', 7, 'Listing Expiration Warning (7 days left)', 'Dear Member!\n\nWe''d like to remind you that in ##hw_days_rem## days your listing will expire.\n\n--- Listing Details ---\n\nURL : ##SITE_URL####ad_url##\nID : ##link_id##\nCategory : ##cname##\n##email_rows##\n\n\nRegards, \n\n##COMPANY##\n##SITE_URL##', 1),
(4, 'FEE', '', 0, 'Listing Expired', 'Dear Member!\n\nYour listing has expired.\n\nTo renew please use the following url :\n##SITE_URL##index.php?page=order&id=##link_id##&cid=##catid##\n\n--- Listing details ---\n\nURL : ##SITE_URL####ad_url##\nID : ##link_id##\nCategory : ##cname##\n##email_rows##\n\n\nRegards,\n\n##COMPANY##\n##SITE_URL##', 1),
(5, 'SUB', '', 7, 'Account Expiration Warning (7 days left)', ' Dear ##username##!\n\n We''d like to remind you that in ##hw_days_rem## days your account will expire.\n \n You can upgrade your membership here:\n##SITE_URL##index.php?page=order\n\n Regards,\n\n ##COMPANY##\n ##SITE_URL##', 1),
(6, 'SUB', '', 0, 'Account Expired', ' Dear ##username##!\n\n Your account has expired.\n \n You can upgrade your membership here:\n##SITE_URL##index.php?page=order\n\n Regards,\n\n ##COMPANY##\n ##SITE_URL##', 1),
(7, 'EXTRA', '', 14, 'Listing Extra Option Expiration Warning (14 days left)', 'Dear Member!\n\nWe''d like to remind you that your listing extra option (##extra_opt_descr## - ##extra_opt_val##) will expire in ##hw_days_rem## days.\n\n--- Listing details ---\n\nURL : ##SITE_URL####ad_url##\nID : ##link_id##\nCategory : ##cname##\n##email_rows##\n\n\nRegards,\n\n##COMPANY##\n##SITE_URL##', 1),
(8, 'EXTRA', '', 7, 'Listing Extra Option Expiration Warning (7 days left)', 'Dear Member!\n\nWe''d like to remind you that your listing extra option (##extra_opt_descr## - ##extra_opt_val##) will expire in ##hw_days_rem## days.\n\n--- Listing details ---\n\nURL : ##SITE_URL####ad_url##\nID : ##link_id##\nCategory : ##cname##\n##email_rows##\n\n\nRegards,\n\n##COMPANY##\n##SITE_URL##', 1),
(9, 'EXTRA', '', 0, 'Listing Extra Option Expired', 'Dear Member!\n\nYour listing extra option (##extra_opt_descr## - ##extra_opt_val##) has expired.\n\nTo renew please use the following url :\n##SITE_URL##index.php?page=order&id=##link_id##&cid=##catid##\n\n--- Listing details ---\n\nURL : ##SITE_URL####ad_url##\nID : ##link_id##\nCategory : ##cname##\n##email_rows##\n\n\nRegards,\n\n##COMPANY##\n##SITE_URL##', 1)",

);

?>